﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports; // erforderlich für SerialPort



namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        SerialPort _serialPort; // Globale Deklaration

        public Form1()
        {
            InitializeComponent();

            // Initialisieren des seriellen Ports
            _serialPort = new SerialPort();

            // Alle COM-Ports von 1 bis 30 werden durchprobiert
            // und angezeigt, wenn sie existieren
            string sAusgabe = "";
            string sCOMNumber = "";
            string sSelectedCOMPort = "";

            for (int i = 1; i < 30; i++)
            {
                // Zähler i in String umwandeln
                sCOMNumber = i.ToString();
                // COM-Port vorsichtshalber erst einmal schließen
                if (_serialPort.IsOpen) _serialPort.Close();
                // COM-Ports nacheinander ausprobieren
                _serialPort.PortName = "COM" + sCOMNumber;
                _serialPort.BaudRate = 9600;
                // _serialPort.ReadTimeout = 500;
                try
                {
                    _serialPort.Open(); //Serialport öffnen
                    sAusgabe = sAusgabe + "COM" + sCOMNumber + " ";
                   // COMPorts[i] = i;
                   // Gefundene COM-Ports in Combobox schreiben
                   // COM1, COM2...COM15 erzeugen
                    //sChoosenCOMPort = i.ToString();
                   comboBoxCOMPorts.Items.Add("COM" + sCOMNumber);
                   sSelectedCOMPort = "COM" + sCOMNumber;
                }
                catch
                {

                }
            }
            // Letzten gefundenen COM-Port als "ausgewählt" anzeigen
            // Dies ist meist der richtige Arduino-Port
            comboBoxCOMPorts.SelectedItem = sSelectedCOMPort;
            // Alle gefundenen COM-Ports nacheinander in Textbox anzeigen
            textBoxCOMPorts.Text = sAusgabe;
        }

        private void buttonCheckCOM_Click(object sender, EventArgs e)
        {
            // Zeichen "b" zum Test senden
            if (_serialPort.IsOpen) _serialPort.Close();
            // Gewählten COM-Port aus Combobox auslesen:
            _serialPort.PortName = comboBoxCOMPorts.SelectedItem.ToString();
            _serialPort.Open(); //Serialport öffnen
            _serialPort.Write("b"); // Ein Zeichen senden
        }
    }
}
